<template>
  <nav class="gallery__paging" >
    <button class="gallery__paging__cmd gallery__paging__cmd--symbol"  v-on:click="goToFirst()" :disabled="isFirstPage">&laquo;</button>
    <button class="gallery__paging__cmd gallery__paging__cmd--symbol"  v-on:click="goToPrevious()" :disabled="isFirstPage">&lsaquo;</button>
    <button class="gallery__paging__cmd" v-for="page in pageCount" v-bind:key="page"
      v-bind:class="{ 'is-active': isActive(page) }"
      v-on:click="onClick(page)">
      {{page}}
    </button>
    <button class="gallery__paging__cmd gallery__paging__cmd--symbol"  v-on:click="goToNext()" :disabled="isLastPage">&rsaquo;</button>
    <button class="gallery__paging__cmd gallery__paging__cmd--symbol"  v-on:click="goToLast()" :disabled="isLastPage">&raquo;</button>
  </nav>
</template>

<script>
export default {
  name: "Paginator",
  props: {
    pageCount: {
      default: 0,
      type: Number
    },
    activePage: {
      default: 0,
      type: Number
    }
  },
  methods: {
    isActive: function(page) {
      return page === this.activePage;
    },
    emitPageChange: function(page) {
      this.$emit("pageChange", page);
    },
    onClick: function(page) {
      this.emitPageChange(page);
    },
    goToPrevious: function() {
      this.emitPageChange(this.activePage - 1);
    },
    goToNext: function() {
      this.emitPageChange(this.activePage + 1);
    },
    goToFirst: function() {
      this.emitPageChange(1);
    },
    goToLast: function() {
      this.emitPageChange(this.pageCount);
    }
  },
  computed: {
    isLastPage: function() {
      return this.activePage === this.pageCount;
    },
    isFirstPage: function() {
      return this.activePage === 1;
    }
  }
};
</script>

<style scoped lang="scss">
@import "../styles/theme.scss";

.gallery__paging {
  text-align: center;
}

.gallery__paging__cmd {
  padding: 0 0.25em;
  margin: auto 0.25em;
}

.gallery__paging__cmd--symbol {
  font-size: 2em;
  vertical-align: sub;

  &:hover {
    color: $primary-color;
  }
}

.gallery__paging__cmd.is-active {
  border-bottom: 2px solid;
}

.gallery__paging__cmd[disabled=disabled] {
  color: $neutral-color;
}
</style>